/*
 *	kuro_rs-pseudo_firmware.c
 *
 *	KURO-RS@̋琄AKURO-RSt@[EFA̋^\[X
 *	RpC͒ʂ܂B̂߂ɍ쐬A^\[XłB
 *
 *	* Tue Nov 27 22:51:32 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 */

/****************************************************************************
 *	ʓr`ĂƉ肷Tu[`
 ****************************************************************************/

extern int recv_from_pc();		/* PC1oCgMB(0x00`0xFF = Mf[^, -1 = Mf[^) */
extern void send_to_pc(int data);	/* PC1oCgMB */
extern int get_0_1ms_timer();		/* ݎ0.1~bPʂŎ擾B */
extern int pd_stat();			/* {̂̍ʂɓĂwx(Photo Diode)̎Ԃ擾B(0 = ĂȂ, 1 = Ă) */
extern void ir_on(int port, int on);	/* ԊOM̐ɕtĂwx̔Ԃݒ肷B(0 = , 1 = ) */
extern void access_blink(int type);	/* {̂̉EɓĂwANZXvx_łB(type = _Ńp^[) */

/****************************************************************************
 *	[J֐錾
 ****************************************************************************/

static void rx_mode();	/* wK[h */
static void tx_mode();	/* M[h */
static void id_mode();	/* ʃ[h */

/****************************************************************************
 *	[hĎ
 ****************************************************************************/

void
main()
{
	int c;

	for(;;) {
		c = recv_from_pc();
		if(c >= 0) {
			switch(c) {
			case 'r':
				rx_mode();	/* wK[h */
				break;
			case 't':
				tx_mode();	/* M[h */
				break;
			case 'i':
				id_mode();	/* ʃ[h */
				break;
			}
		}
	}
}

/****************************************************************************
 *	wK[h
 ****************************************************************************/

static void
rx_mode()
{
	int c;
	int i;
	int j;
	int t;
	unsigned char buf[240];

	/* PC'Y'𑗐MB */
	send_to_pc('Y');

	/* ԊO邩ALZ܂ő҂܂B */
	while(!pd_stat()) {
		if(recv_from_pc() >= 0) {
			/* PC'Y'𑗐MA[hĎԂɖ߂܂B
			 * wԊORg[dlxł́ALZR}h'c'ƂȂĂ܂A
			 *   ۂɂ́A'c'ł'c'ȊOłłLZR}hƌȂ悤łB
			 * LZ'Y'̑M̗LAM[hƑM[hňقȂ悤łB
			 */
			send_to_pc('Y');
			return;
		}
	}

	/* 0.1~bԊuŎԂTvOARf[^ƂĊi[܂B */
	t = get_0_1ms_timer();
	for(i = 0; i < 240; i++) {
		buf[i] = 0;
		for(j = 0; j < 8; j++) {
			if(pd_stat()) {
				buf[i] |= (1 << j);	/* LSBs */
			}
			/* 0.1~bԊũ^C~O҂B */
			while(get_0_1ms_timer() == t) { /** no job **/ }
			t++;
		}
	}

	/* PC'S'𑗐M܂B */
	send_to_pc('S');

	/* PCփRf[^𑗐M܂B */
	for(i = 0; i < 240; i++) {
		send_to_pc(buf[i]);
	}

	/* ANZXv3_ł܂B
	 * PC'E'𑗐MOɃANZXv_ł܂B_ł܂'E'͑M܂B
	 *   M[h⎯ʃ[h̏ꍇ́AׂĂ̑MƂɃANZXv_łāA
	 *   _łI璼ɂɃ[hĎԂɖ߂Ă̂ƊrׂƁAwK[hłB
	 */
	access_blink(3);

	/* PC'E'𑗐M܂B */
	send_to_pc('E');

	/* [hĎԂɖ߂܂B */
}

/****************************************************************************
 *	M[h
 ****************************************************************************/

static void
tx_mode()
{
	int c;
	int port;
	int i;
	int j;
	int t;
	unsigned char buf[240 + 2];	/* u+2vKURO-RS@̋琄܂Bȉ̃RgQƂĂB */

	/* PC'Y'𑗐MB */
	send_to_pc('Y');

	/* PC|[gԍM܂B */
	for(;;) {
		c = recv_from_pc();
		if(c >= 0) {
			if((c >= '1') && (c <= '4')) {
				port = c - '0';
				/* PC'Y'𑗐MARf[^M҂ֈڍs܂B */
				send_to_pc('Y');
				break;
			} else {
				/* PC։MɁA[hĎԂɖ߂܂B
				 * wԊORg[dlxł́ALZR}h'c'ƂȂĂ܂A
				 *   ۂɂ́A'1'`'4'ȊOȂΉłLZR}hƌȂ悤łB
				 * LZ'Y'̑M̗LAM[hƑM[hňقȂ悤łB
				 */
				return;
			}
		}
	}
	/* ȍ~AM[hI܂ŁALZ͂ł܂B
	 *   PĆARf[^240oCgMāAK̎菇őM[h邵܂B
	 *   ȂȂ΁A0x00240oCgMΔȂ͂Ȃ̂ŁALZł邩m܂B()
	 */

	/* PC烊Rf[^240oCgM܂B
	 * KURO-RSɃoOA243oCgȏMƁAnOAbvĂ܂悤łB
	 *   239oCgȉ -> v240oCgȏɂȂ܂ŁA̎M҂܂B
	 *   240oCg     -> M܂B
	 *   241oCg     -> ]ɎM1oCĝĂāAM܂B
	 *   242oCg     -> ]ɎM2oCĝĂāAM܂B
	 *   243oCgȏ -> nOAbv܂BKURO-RSȂȂƁA܂B
	 */
	i = 0;
	for(;;) {
		c = recv_from_pc();
		if(c >= 0) {
			buf[i++] = c;
			continue;	/* oO(KURO-RS@̋琄)B́ucontinue;v΁AɂȂ܂B */
		}
		if(i >= 240) {
			break;
		}
	}

	/* Rf[^ɏ]āA0.1~bԊuŔA܂́A܂B */
	t = get_0_1ms_timer();
	for(i = 0; i < 240; i++) {
		for(j = 0; j < 8; j++) {
			if(buf[i] & (1 << j)) {		/* LSBs */
				ir_on(port, 1);
			} else {
				ir_on(port, 0);
			}
			/* 0.1~bԊũ^C~O҂B */
			while(get_0_1ms_timer() == t) { /** no job **/ }
			t++;
		}
	}

	/* mɔ܂B */
	ir_on(port, 0);

	/* PC'E'𑗐M܂B */
	send_to_pc('E');

	/* ANZXv΂₭2_ł܂B */
	access_blink(2);

	/* [hĎԂɖ߂܂B */
}

/****************************************************************************
 *	ʃ[h
 ****************************************************************************/

static void
id_mode()
{
	/* PC'O'𑗐M܂B */
	send_to_pc('O');

	/* ANZXv1_ł܂B */
	access_blink(1);

	/* [hĎԂɖ߂܂B */
}

